
#define	STRICT
#define	WIN32_LEAN_AND_MEAN


#pragma check_stack(off)
#pragma optimize("gsy",on)
#pragma comment(linker,"/ENTRY:DllMain")
#pragma comment(linker,"/opt:nowin98")
#pragma comment(linker,"/merge:.rdata=.data")
#pragma comment(linker,"/merge:.text=.data")
#pragma comment(linker,"/merge:.reloc=.data")
#pragma comment(linker,"/ignore:4078")


#include <windows.h>
#include <Winsvc.h>
#include "dll.h"

/*
 *	USELESS - DLL Project	
 *  This component facilitates the mIRC->Driver interface required to allow mIRC to modify the Keyboard LEDs
 *
 *  Copyright (c)2003 Brad Basler, All Rights Reserved.
 */



int WINAPI DllMain(HANDLE handle,DWORD reason,LPVOID reserved)
{
	return TRUE;
}


int __stdcall Uninstall(HWND mWnd,HWND aWnd,char *data,char *parms,BOOL show,BOOL nopause)
{
	SC_HANDLE SvcCntrlHandle;
	SC_HANDLE SvcHandle;

	SvcCntrlHandle = OpenSCManager(
						NULL,NULL,
						SC_MANAGER_ALL_ACCESS
					 );

	if (!SvcCntrlHandle)
	switch(GetLastError())
	{

		case ERROR_ACCESS_DENIED:

			lstrcpy(data,"Error: Access Denied");
			break;

		default:
			lstrcpy(data,"Error: SCM Could not be connected with (Error Unknown)");

	}
	else
	{

		SvcHandle = OpenService(
						SvcCntrlHandle,
						"Useless",
						DELETE
					);

		if (!SvcHandle)
		switch(GetLastError())
		{

			case ERROR_ACCESS_DENIED:
				lstrcpy(data,"Error: Access Denied");
				break;

			case ERROR_INVALID_NAME:
				lstrcpy(data,"Error: Invalid Name");
				break;

			case ERROR_SERVICE_DOES_NOT_EXIST:
				lstrcpy(data,"Error: Driver does not exist (Not installed?)");
				break;

		}
		else
		{

			lstrcpy(data,"Ok - Uninstalled");

			DeleteService(SvcHandle);

			CloseServiceHandle(SvcHandle);
		}


		CloseServiceHandle(SvcCntrlHandle);
	}

	return 3;
}

int __stdcall Install(HWND mWnd,HWND aWnd,char *data,char *parms,BOOL show,BOOL nopause)
{
	SC_HANDLE SvcCntrlHandle;
	SC_HANDLE SvcHandle;

	SvcCntrlHandle = OpenSCManager(
						NULL,NULL,
						SC_MANAGER_ALL_ACCESS
					 );

	if (!SvcCntrlHandle)
	switch(GetLastError())
	{

		case ERROR_ACCESS_DENIED:

			lstrcpy(data,"Error: Access Denied");
			break;

		default:
			lstrcpy(data,"Error: SCM Could not be connected with (Error Unknown)");

	}
	else
	{

		TCHAR *pFile;
		TCHAR  Path[MAX_PATH];

		GetFullPathName(data,MAX_PATH,(TCHAR*)&Path,&pFile);

		HANDLE hTemp = CreateFile(
							Path,
							GENERIC_READ,
							FILE_SHARE_READ|FILE_SHARE_WRITE,
							NULL,
							OPEN_EXISTING,
							FILE_ATTRIBUTE_NORMAL,
							NULL
					   );

		//Close it, we just want to see if it existed
		CloseHandle(hTemp);

		if (hTemp == INVALID_HANDLE_VALUE)
			wsprintf(data,"Error: Specified driver could not be located: %s",Path);
		else		
		{		

			SvcHandle = CreateService(
							SvcCntrlHandle,
							"Useless",
							"Absolutely Useless LED Keyboard Control",
							SERVICE_ALL_ACCESS,
							SERVICE_KERNEL_DRIVER,
							SERVICE_DEMAND_START,
							SERVICE_ERROR_IGNORE,
							Path,
							NULL,NULL,
							NULL,NULL,
							NULL
						);	

			if (!SvcHandle)
			switch(GetLastError())
			{
	
				case ERROR_ACCESS_DENIED:
					lstrcpy(data,"Error: Access Denied");
					break;

				case ERROR_DUP_NAME:
				case ERROR_SERVICE_EXISTS:
					lstrcpy(data,"Error: Driver already Installed");
					break;

				case ERROR_INVALID_NAME:
					lstrcpy(data,"Error: Service Name Invalid (File not Found?)");
					break;

				default:
					lstrcpy(data,"Error: Driver could not be installed (reason unknown)");
				
			}
			else
			{
				lstrcpy(data,"Ok - Installed");

				CloseServiceHandle(SvcHandle);	
			}

		}

		CloseServiceHandle(SvcCntrlHandle);
	}

	return 3;
}

int __stdcall Start(HWND mWnd,HWND aWnd,char *data,char *parms,BOOL show,BOOL nopause)
{

	SC_HANDLE SvcCntrlHandle;

	SvcCntrlHandle = OpenSCManager(
							NULL,NULL,
							SC_MANAGER_CONNECT	\
							|GENERIC_READ|GENERIC_EXECUTE
					 );

	if (!SvcCntrlHandle)
	switch(GetLastError())
	{

		case ERROR_ACCESS_DENIED:
			lstrcpy(data,"Error: Access Denied");
			break;

		default:
			lstrcpy(data,"Error: SCM Could not be connected with (Error Unknown)");

	}
	else
	{
		SC_HANDLE SvcHandle;

		SvcHandle = OpenService(SvcCntrlHandle,"Useless",SERVICE_ALL_ACCESS);

		if (!SvcCntrlHandle)
		switch(GetLastError())
		{

			case ERROR_ACCESS_DENIED:
				lstrcpy(data,"Error: Access Denied (Service could not be opened)");
				break;

			default:
				lstrcpy(data,"Error: Service could not be opened (reason unknown)");

		}
		else
		{
			if (!StartService(SvcHandle,NULL,NULL))
			switch(GetLastError())
			{

				case ERROR_ACCESS_DENIED:
					lstrcpy(data,"Error: Access Denied (Service could not be started)");
					break;

				case ERROR_SERVICE_DISABLED:
					lstrcpy(data,"Error: Access Denied (Service has been disabled)");
					break;

				case ERROR_SERVICE_ALREADY_RUNNING:
					lstrcpy(data,"Error: Driver is already started");
					break;

				case ERROR_PATH_NOT_FOUND:
					lstrcpy(data,"Error: useless.sys could not be loaded");
					break;

				default:
					lstrcpy(data,"Error: Driver useless.sys could not be started (reason unknown)");
					break;

			}
			else
				lstrcpy(data,"Ok - Started");

			CloseServiceHandle(SvcHandle);
		}

		CloseServiceHandle(SvcCntrlHandle);
	}

	return 3;

}

int __stdcall Stop(HWND mWnd,HWND aWnd,char *data,char *parms,BOOL show,BOOL nopause)
{

	SC_HANDLE SvcCntrlHandle;


	SvcCntrlHandle = OpenSCManager(
						NULL,NULL,
						SC_MANAGER_CONNECT	\
						|GENERIC_READ|GENERIC_EXECUTE
						);

	if (!SvcCntrlHandle)
	switch(GetLastError())
	{

		case ERROR_ACCESS_DENIED:

			lstrcpy(data,"Error: Access Denied");
			break;

		default:
			lstrcpy(data,"Error: SCM Could not be connected with (Error Unknown)");

	}
	else
	{

		SC_HANDLE SvcHandle;

		SvcHandle = OpenService(SvcCntrlHandle,"Useless",SERVICE_ALL_ACCESS);

		if (!SvcCntrlHandle)
		switch(GetLastError())
		{

			case ERROR_ACCESS_DENIED:
				lstrcpy(data,"Error: Access Denied (Service could not be opened)");
				break;

			default:
				lstrcpy(data,"Error: Service could not be opened (reason unknown)");

		}
		else
		{
			SERVICE_STATUS SvcStatus;

			RtlZeroMemory(&SvcStatus,sizeof SvcStatus);

			if (!ControlService(SvcHandle,SERVICE_CONTROL_STOP,&SvcStatus))
			switch(GetLastError())
			{

				case ERROR_ACCESS_DENIED:
					lstrcpy(data,"Error: Access Denied (Service could not be stopped)");
					break;

				case ERROR_SERVICE_NOT_ACTIVE:
					lstrcpy(data,"Error: Driver was never started");
					break;

				default:
					lstrcpy(data,"Error: Driver could not be stopped (Unknown error occured)");
					break;

			}
			else
				lstrcpy(data,"Ok - Stopped");
			
			CloseServiceHandle(SvcHandle);
		}

		CloseServiceHandle(SvcCntrlHandle);
	}



	return 3;
}


int __stdcall SetLEDs(HWND mWnd,HWND aWnd,char *data,char *parms,BOOL show,BOOL nopause)
{
	HANDLE hDevice = CreateFile("\\\\.\\Useless_LED_Controller",                
								GENERIC_READ | GENERIC_WRITE, 
								FILE_SHARE_READ | FILE_SHARE_WRITE,
								0,                     // Default security
								OPEN_EXISTING,
								FILE_FLAG_OVERLAPPED,  // Perform asynchronous I/O
								0
					);

	if (hDevice == INVALID_HANDLE_VALUE)
		lstrcpy(data,"Error: Could not communicate with driver (Not started?)");

	else {

		UCHAR NewLEDs;
		DWORD BytesReturned;

		NewLEDs = max(min(7,data[0]-'0'),0);

		if (!DeviceIoControl(hDevice,
						UIOCTL_SET_LEDS,
						&NewLEDs,
						sizeof NewLEDs,
						NULL,
						NULL,
						&BytesReturned,
						NULL
					))
				lstrcpy(data,"Error: Could not communicate with driver (Communication Restricted?)");
			else
				lstrcpy(data,"OK");

		CloseHandle(hDevice);
	}

	return 3;
}

int __stdcall DLLInfo(HWND mWnd,HWND aWnd,char *data,char *parms,BOOL show,BOOL nopause)
{
	lstrcpy(data,"useless.dll - Keyboard LED controller, Copyright(c) 2003 Brad Basler. All Rights Reserved");
	return 3;
}
